︠44884b66-5dc0-4397-ba7c-95d581b01befi︠
%md
# Math 582: computational number theory

## Homework 5 -- due by Friday Feb 12 at 9am
︡6ddbb820-c030-494b-ad17-a8fc0c3fbb4d︡︡{"done":true,"md":"# Math 582: computational number theory\n\n## Homework 5 -- due by Friday Feb 12 at 9am"}
︠eb17f831-92e0-432a-a923-8ab4c39091bai︠

%md

## Problem 3:
Explicitly run the Round 2 algorithm, using the code from class on Feb 5, to compute the ring of
integers of a non-monogenic field (one whose ring of integers isn't generated by a single
element), but starting with the order $\ZZ[\alpha]$.

You can easily find such a field by Googling for nonmonogenic field.
︡71ca01e8-0421-40d3-99cd-f41c50feeb17︡︡{"done":true,"md":"\n## Problem 3:\nExplicitly run the Round 2 algorithm, using the code from class on Feb 5, to compute the ring of\nintegers of a non-monogenic field (one whose ring of integers isn't generated by a single\nelement), but starting with the order $\\ZZ[\\alpha]$.\n\nYou can easily find such a field by Googling for nonmonogenic field."}
︠930150a1-53e5-455d-85b8-ac2b3e12e80as︠
R.<x> = QQ[]
K.<alpha> = NumberField(x^3 - x^2 - 2*x - 8) # Dedekind's example, see https://en.wikipedia.org/wiki/Monogenic_field
K.ring_of_integers().basis()
︡8c8f7979-2841-4083-82cb-e37a70fb3179︡︡{"stdout":"[1, 1/2*alpha^2 + 1/2*alpha, alpha^2]\n","done":false}︡{"done":true}
︠00dc086a-2e3e-4656-9ddc-aa1f68a28112s︠
# our startiong order
S = K.order(alpha) # it seems like ZZ[alpha] almost works...
S.discriminant().factor()
︡88571668-be09-4325-a54d-c0317a28d5e9︡︡{"stdout":"-1 * 2^2 * 503\n","done":false}︡{"done":true}
︠1202f0ca-05fd-4e59-9f44-e0a33da08b21︠
# shows the only prime which S is not maximal at is 2.
# We only computed the discriminant of x^3 - x^2 - 2*x - 8
# so we aren't cheating here. Also it means we only have to
# run round 2 one time and we are garunteed to be done.
︡352e0806-e97d-400a-9706-02b04205f051︡︡{"done":true}
︠0d9213c2-59e2-403a-b168-7abc68e3c1ec︠
def consolelog(s, args):
    print s, args
def p_radical(S, p):
    """
    INPUT:
       - S -- an order in a number field K (assumed to be an absolute number field!)
       - p -- a prime number

    OUTPUT: the p-radical of S.
    """
    K = S.number_field()
    n = K.degree()
    consolelog("n =", n)

    pj = ceil(log(n,p))
    consolelog("p^j =", pj)

    powers = [x^pj for x in S.basis()]  # this could be optimized by reducing each time -- would be the bottlekneck right now
    consolelog("powers =", powers)

    M = S.free_module()
    coords = [M.coordinates(list(y)) for y in powers]
    consolelog("coords =", coords)

    A = matrix(GF(p), n, coords)
    consolelog("matrix =", A)

    gens = []
    V = A.kernel()
    consolelog("Kernel =", V)

    for b in V.basis():
        gens.append(M.linear_combination_of_basis(b.lift()))

    return M*p + M.span(gens)
def phi_bar(S, p, I_p):
    # For each basis element of S, see how it acts on I_p modulo p*I_p.
    B = I_p.basis()  # basis of a free module
    consolelog("I_p has basis ", B)
    B2 = [S(b) for b in B]
    consolelog("Moving these elements into S for arithmetic: ", B2)
    rows = []
    for g in S.gens():
        row = sum([I_p.coordinates(list(g*c)) for c in B2], [])
        rows.append(row)
    consolelog("rows of matrix: ", rows)
    phi_matrix = matrix(GF(p), rows)
    return phi_matrix
def compute_U(S, p, I_p):
    mat = phi_bar(S, p, I_p)
    consolelog("the matrix is ", mat)

    V = mat.kernel()
    consolelog("kernel ", V)

    M = S.free_module()
    gens = []
    for b in V.basis():
        gens.append(M.linear_combination_of_basis(b.lift()))
    consolelog("lift of kernel elements", gens)

    U = M*p + M.span(gens)
    consolelog("adding together with p*S yields", U)

    return U
def compute_T_from_U(S, U, p):
    return K.order([K(b/p) for b in U.basis()])
def compute_T(S, p):
    I_p = p_radical(S, p)
    U   = compute_U(S, p, I_p)
    T   = compute_T_from_U(S, U, p)
    return T
︡57c0f86c-4efe-424e-87e2-8e7546420c6b︡︡{"done":true}
︠df7e85ae-d04e-40de-a55b-580fe90851f7s︠
T = compute_T(S,2)
︡74b68a9e-e2ea-4e95-8064-d2f30734123d︡︡{"stdout":"n = 3\np^j = 2\npowers = [1, alpha^2, 3*alpha^2 + 10*alpha + 8]\ncoords = [[1, 0, 0], [0, 0, 1], [8, 10, 3]]\nmatrix = [1 0 0]\n[0 0 1]\n[0 0 1]\nKernel = Vector space of degree 3 and dimension 1 over Finite Field of size 2\nBasis matrix:\n[0 1 1]\nI_p has basis  [\n(2, 0, 0),\n(0, 1, 1),\n(0, 0, 2)\n]\nMoving these elements into S for arithmetic:  [2, alpha^2 + alpha, 2*alpha^2]\nrows of matrix:  [[1, 0, 0, 0, 1, 0, 0, 0, 1], [0, 2, -1, 4, 2, 0, 8, 4, -1], [0, 0, 1, 8, 12, -4, 8, 20, -7]]\nthe matrix is  [1 0 0 0 1 0 0 0 1]\n[0 0 1 0 0 0 0 0 1]\n[0 0 1 0 0 0 0 0 1]\nkernel  Vector space of degree 3 and dimension 1 over Finite Field of size 2\nBasis matrix:\n[0 1 1]\nlift of kernel elements [(0, 1, 1)]\nadding together with p*S yields Free module of degree 3 and rank 3 over Integer Ring\nEchelon basis matrix:\n[2 0 0]\n[0 1 1]\n[0 0 2]\n","done":false}︡{"done":true}
︠5d4ce23d-04ba-4a87-bf2c-9513005c093cs︠
T.basis()
︡8c4cfa96-4986-4a17-8666-395522a15d2b︡︡{"stdout":"[1, 1/2*alpha^2 + 1/2*alpha, alpha^2]\n","done":false}︡{"done":true}
︠1370549f-7b58-47fc-a0b5-589919ac116as︠
T == K.ring_of_integers()
︡acf54338-f79f-4649-8563-045fef3d3116︡︡{"stdout":"True\n","done":false}︡{"done":true}
︠4accaf0c-736b-4604-a20a-1deaaec506fe︠









